diff a/src/hotspot/share/cds/archiveUtils.cpp b/src/hotspot/share/cds/archiveUtils.cpp
--- a/src/hotspot/share/cds/archiveUtils.cpp
+++ b/src/hotspot/share/cds/archiveUtils.cpp
@@ -31,10 +31,11 @@
 #include "cds/classListWriter.hpp"
 #include "cds/dynamicArchive.hpp"
 #include "cds/filemap.hpp"
 #include "cds/heapShared.hpp"
 #include "cds/metaspaceShared.hpp"
+#include "classfile/classLoader.hpp"
 #include "classfile/systemDictionaryShared.hpp"
 #include "classfile/vmClasses.hpp"
 #include "interpreter/bootstrapInfo.hpp"
 #include "memory/metaspaceUtils.hpp"
 #include "memory/resourceArea.hpp"
@@ -47,18 +48,20 @@
 #include "utilities/globalDefinitions.hpp"
 
 CHeapBitMap* ArchivePtrMarker::_ptrmap = nullptr;
 CHeapBitMap* ArchivePtrMarker::_rw_ptrmap = nullptr;
 CHeapBitMap* ArchivePtrMarker::_ro_ptrmap = nullptr;
+CHeapBitMap* ArchivePtrMarker::_cc_ptrmap = nullptr;
 VirtualSpace* ArchivePtrMarker::_vs;
 
 bool ArchivePtrMarker::_compacted;
 
 void ArchivePtrMarker::initialize(CHeapBitMap* ptrmap, VirtualSpace* vs) {
   assert(_ptrmap == nullptr, "initialize only once");
   assert(_rw_ptrmap == nullptr, "initialize only once");
   assert(_ro_ptrmap == nullptr, "initialize only once");
+  assert(_cc_ptrmap == nullptr, "initialize only once");
   _vs = vs;
   _compacted = false;
   _ptrmap = ptrmap;
 
   // Use this as initial guesstimate. We should need less space in the
@@ -70,39 +73,57 @@
 
   // We need one bit per pointer in the archive.
   _ptrmap->initialize(estimated_archive_size / sizeof(intptr_t));
 }
 
-void ArchivePtrMarker::initialize_rw_ro_maps(CHeapBitMap* rw_ptrmap, CHeapBitMap* ro_ptrmap) {
+void ArchivePtrMarker::initialize_rw_ro_cc_maps(CHeapBitMap* rw_ptrmap, CHeapBitMap* ro_ptrmap, CHeapBitMap* cc_ptrmap) {
   address* rw_bottom = (address*)ArchiveBuilder::current()->rw_region()->base();
   address* ro_bottom = (address*)ArchiveBuilder::current()->ro_region()->base();
+  address* cc_bottom = (address*)ArchiveBuilder::current()->cc_region()->base();
 
   _rw_ptrmap = rw_ptrmap;
   _ro_ptrmap = ro_ptrmap;
+  _cc_ptrmap = cc_ptrmap;
 
   size_t rw_size = ArchiveBuilder::current()->rw_region()->used() / sizeof(address);
   size_t ro_size = ArchiveBuilder::current()->ro_region()->used() / sizeof(address);
+  size_t cc_size = ArchiveBuilder::current()->cc_region()->used() / sizeof(address);
   // ro_start is the first bit in _ptrmap that covers the pointer that would sit at ro_bottom.
   // E.g., if rw_bottom = (address*)100
   //          ro_bottom = (address*)116
   //       then for 64-bit platform:
   //          ro_start = ro_bottom - rw_bottom = (116 - 100) / sizeof(address) = 2;
   size_t ro_start = ro_bottom - rw_bottom;
+  size_t cc_start = cc_bottom - rw_bottom;
 
-  // Note: ptrmap is big enough only to cover the last pointer in ro_region.
+  // Note: ptrmap is big enough only to cover the last pointer in cc_region or ro_region.
   // See ArchivePtrMarker::compact()
+  if (ro_start + ro_size >_ptrmap->size()) {
+    ro_size = _ptrmap->size() - ro_start; // ro is smaller than we thought
+    cc_size = 0;                          // cc is empty
+  } else if (cc_size != 0 && cc_start + cc_size > _ptrmap->size()) {
+    cc_size = _ptrmap->size() - cc_start; // ro is smaller than we thought
+  }
+
+  assert(rw_size < _ptrmap->size(), "sanity");
+  assert(ro_size < _ptrmap->size(), "sanity");
+  assert(cc_size < _ptrmap->size(), "sanity");
+  assert(rw_size + ro_size + cc_size <= _ptrmap->size(), "sanity");
+
   _rw_ptrmap->initialize(rw_size);
-  _ro_ptrmap->initialize(_ptrmap->size() - ro_start);
+  _ro_ptrmap->initialize(ro_size);
+  _cc_ptrmap->initialize(cc_size);
 
-  for (size_t rw_bit = 0; rw_bit < _rw_ptrmap->size(); rw_bit++) {
-    _rw_ptrmap->at_put(rw_bit, _ptrmap->at(rw_bit));
+  for (size_t i = 0; i < rw_size; i++) {
+    _rw_ptrmap->at_put(i, _ptrmap->at(i));
   }
-
-  for(size_t ro_bit = ro_start; ro_bit < _ptrmap->size(); ro_bit++) {
-    _ro_ptrmap->at_put(ro_bit-ro_start, _ptrmap->at(ro_bit));
+  for (size_t i = 0; i < ro_size; i++) {
+    _ro_ptrmap->at_put(i, _ptrmap->at(ro_start + i));
+  }
+  for (size_t i = 0; i < cc_size; i++) {
+    _cc_ptrmap->at_put(i, _ptrmap->at(cc_start + i));
   }
-  assert(_ptrmap->size() - ro_start == _ro_ptrmap->size(), "must be");
 }
 
 void ArchivePtrMarker::mark_pointer(address* ptr_loc) {
   assert(_ptrmap != nullptr, "not initialized");
   assert(!_compacted, "cannot mark anymore");
@@ -262,13 +283,14 @@
     ArchivePtrMarker::mark_pointer(p);
   }
 }
 
 void DumpRegion::print(size_t total_bytes) const {
+  char* base = used() > 0 ? ArchiveBuilder::current()->to_requested(_base) : nullptr;
   log_debug(cds)("%s space: " SIZE_FORMAT_W(9) " [ %4.1f%% of total] out of " SIZE_FORMAT_W(9) " bytes [%5.1f%% used] at " INTPTR_FORMAT,
                  _name, used(), percent_of(used(), total_bytes), reserved(), percent_of(used(), reserved()),
-                 p2i(ArchiveBuilder::current()->to_requested(_base)));
+                 p2i(base));
 }
 
 void DumpRegion::print_out_of_space_msg(const char* failing_region, size_t needed_bytes) {
   log_error(cds)("[%-8s] " PTR_FORMAT " - " PTR_FORMAT " capacity =%9d, allocated =%9d",
                  _name, p2i(_base), p2i(_top), int(_end - _base), int(_top - _base));
@@ -287,13 +309,14 @@
   _base = _top = _rs->base();
   _end = _rs->end();
 }
 
 void DumpRegion::pack(DumpRegion* next) {
-  assert(!is_packed(), "sanity");
-  _end = (char*)align_up(_top, MetaspaceShared::core_region_alignment());
-  _is_packed = true;
+  if (!is_packed()) {
+    _end = (char*)align_up(_top, MetaspaceShared::core_region_alignment());
+    _is_packed = true;
+  }
   if (next != nullptr) {
     next->_rs = _rs;
     next->_vs = _vs;
     next->_base = next->_top = this->_end;
     next->_end = _rs->end();
@@ -369,10 +392,60 @@
       }
     }
   }
 }
 
+
+// "boot", "platform", "app" or nullptr
+const char* ArchiveUtils::builtin_loader_name_or_null(oop loader) {
+  if (loader == nullptr) {
+    return "boot";
+  } else if (loader == SystemDictionary::java_platform_loader()) {
+    return "platform";
+  } else if (loader == SystemDictionary::java_system_loader()) {
+    return "app";
+  } else {
+    return nullptr;
+  }
+}
+
+// "boot", "platform", "app". Asserts if not a built-in-loader
+const char* ArchiveUtils::builtin_loader_name(oop loader) {
+  const char* name = builtin_loader_name_or_null(loader);
+  assert(name != nullptr, "must be a built-in loader");
+  return name;
+}
+
+bool ArchiveUtils::builtin_loader_from_type(const char* loader_type, oop* value_ret) {
+  if (strcmp(loader_type, "boot") == 0) {
+    *value_ret = nullptr;
+    return true;
+  } else if (strcmp(loader_type, "platform") == 0) {
+    *value_ret = SystemDictionary::java_platform_loader();
+    return true;
+  } else if (strcmp(loader_type, "app") == 0) {
+    *value_ret = SystemDictionary::java_system_loader();
+    return true;
+  } else {
+    DEBUG_ONLY(*value_ret = cast_to_oop((void*)badOopVal));
+    return false;
+  }
+}
+
+oop ArchiveUtils::builtin_loader_from_type(int loader_type) {
+  if (loader_type == ClassLoader::BOOT_LOADER) {
+    return nullptr;
+  } else if (loader_type == ClassLoader::PLATFORM_LOADER)  {
+    return SystemDictionary::java_platform_loader();
+  } else if (loader_type == ClassLoader::APP_LOADER) {
+    return SystemDictionary::java_system_loader();
+  } else {
+    ShouldNotReachHere();
+    return nullptr;
+  }
+}
+
 bool ArchiveUtils::has_aot_initialized_mirror(InstanceKlass* src_ik) {
   if (SystemDictionaryShared::is_excluded_class(src_ik)) {
     assert(!ArchiveBuilder::current()->has_been_buffered(src_ik), "sanity");
     return false;
   }
@@ -396,6 +469,5 @@
 
 size_t HeapRootSegments::segment_offset(size_t seg_idx) {
   assert(seg_idx < _count, "In range");
   return _base_offset + seg_idx * _max_size_in_bytes;
 }
-
diff a/src/hotspot/share/cds/archiveUtils.hpp b/src/hotspot/share/cds/archiveUtils.hpp
--- a/src/hotspot/share/cds/archiveUtils.hpp
+++ b/src/hotspot/share/cds/archiveUtils.hpp
@@ -47,10 +47,11 @@
 // fixed, but _ptr_end can be expanded as more objects are dumped.
 class ArchivePtrMarker : AllStatic {
   static CHeapBitMap*  _ptrmap;
   static CHeapBitMap*  _rw_ptrmap;
   static CHeapBitMap*  _ro_ptrmap;
+  static CHeapBitMap*  _cc_ptrmap;
   static VirtualSpace* _vs;
 
   // Once _ptrmap is compacted, we don't allow bit marking anymore. This is to
   // avoid unintentional copy operations after the bitmap has been finalized and written.
   static bool         _compacted;
@@ -58,11 +59,11 @@
   static address* ptr_base() { return (address*)_vs->low();  } // committed lower bound (inclusive)
   static address* ptr_end()  { return (address*)_vs->high(); } // committed upper bound (exclusive)
 
 public:
   static void initialize(CHeapBitMap* ptrmap, VirtualSpace* vs);
-  static void initialize_rw_ro_maps(CHeapBitMap* rw_ptrmap, CHeapBitMap* ro_ptrmap);
+  static void initialize_rw_ro_cc_maps(CHeapBitMap* rw_ptrmap, CHeapBitMap* ro_ptrmap, CHeapBitMap* cc_ptrmap);
   static void mark_pointer(address* ptr_loc);
   static void clear_pointer(address* ptr_loc);
   static void compact(address relocatable_base, address relocatable_end);
   static void compact(size_t max_non_null_offset);
 
@@ -87,14 +88,19 @@
 
   static CHeapBitMap* ro_ptrmap() {
     return _ro_ptrmap;
   }
 
+  static CHeapBitMap* cc_ptrmap() {
+    return _cc_ptrmap;
+  }
+
   static void reset_map_and_vs() {
     _ptrmap = nullptr;
     _rw_ptrmap = nullptr;
     _ro_ptrmap = nullptr;
+    _cc_ptrmap = nullptr;
     _vs = nullptr;
   }
 };
 
 // SharedDataRelocator is used to shift pointers in the CDS archive.
@@ -257,10 +263,16 @@
   static const uintx MAX_SHARED_DELTA = 0x7FFFFFFF;
   static void log_to_classlist(BootstrapInfo* bootstrap_specifier, TRAPS) NOT_CDS_RETURN;
   static bool has_aot_initialized_mirror(InstanceKlass* src_ik);
   template <typename T> static Array<T>* archive_array(GrowableArray<T>* tmp_array);
 
+  static const char* builtin_loader_name_or_null(oop loader); // "boot", "platform", "app", or nullptr
+  static const char* builtin_loader_name(oop loader); // "boot", "platform", or "app". Asserts if not a built-in-loader.
+
+  static bool builtin_loader_from_type(const char* loader_type, oop* value_ret);
+  static oop builtin_loader_from_type(int loader_type);
+
   // offset must represent an object of type T in the mapped shared space. Return
   // a direct pointer to this object.
   template <typename T> T static from_offset(u4 offset) {
     T p = (T)(SharedBaseAddress + offset);
     assert(Metaspace::is_in_shared_metaspace(p), "must be");
diff a/src/hotspot/share/cds/cdsAccess.cpp b/src/hotspot/share/cds/cdsAccess.cpp
--- /dev/null
+++ b/src/hotspot/share/cds/cdsAccess.cpp
@@ -0,0 +1,185 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#include "precompiled.hpp"
+#include "cds/archiveBuilder.hpp"
+#include "cds/cdsAccess.hpp"
+#include "cds/cdsConfig.hpp"
+#include "cds/filemap.hpp"
+#include "cds/heapShared.hpp"
+#include "cds/metaspaceShared.hpp"
+#include "classfile/stringTable.hpp"
+#include "logging/log.hpp"
+#include "logging/logStream.hpp"
+#include "memory/resourceArea.hpp"
+#include "memory/universe.hpp"
+#include "memory/virtualspace.hpp"
+#include "oops/instanceKlass.hpp"
+
+size_t _cached_code_size = 0;
+
+bool CDSAccess::can_generate_cached_code(address addr) {
+  if (CDSConfig::is_dumping_final_static_archive()) {
+    return ArchiveBuilder::is_active() && ArchiveBuilder::current()->has_been_archived(addr);
+  } else {
+    // Old CDS+AOT workflow.
+    return MetaspaceShared::is_in_shared_metaspace(addr);
+  }
+}
+
+bool CDSAccess::can_generate_cached_code(InstanceKlass* ik) {
+  if (CDSConfig::is_dumping_final_static_archive()) {
+    if (!ArchiveBuilder::is_active()) {
+      return false;
+    }
+    ArchiveBuilder* builder = ArchiveBuilder::current();
+    if (!builder->has_been_archived((address)ik)) {
+      return false;
+    }
+    InstanceKlass* buffered_ik = builder->get_buffered_addr(ik);
+    if (ik->is_shared_unregistered_class()) {
+      return false;
+    }
+    return true;
+  } else {
+    // Old CDS+AOT workflow.
+    return ik->is_shared() && !ik->is_shared_unregistered_class();
+  }
+}
+
+uint CDSAccess::delta_from_shared_address_base(address addr) {
+  if (CDSConfig::is_dumping_final_static_archive()) {
+    assert(ArchiveBuilder::is_active(), "must be");
+    ArchiveBuilder* builder = ArchiveBuilder::current();
+    address requested_addr = builder->to_requested(builder->get_buffered_addr(addr));
+    return (uint)pointer_delta(requested_addr, (address)SharedBaseAddress, 1);
+  } else {
+    // Old CDS+AOT workflow.
+    return (uint)pointer_delta(addr, (address)SharedBaseAddress, 1);
+  }
+}
+
+Method* CDSAccess::method_in_cached_code(Method* m) {
+  if (CDSConfig::is_dumping_final_static_archive()) {
+    assert(ArchiveBuilder::is_active(), "must be");
+    ArchiveBuilder* builder = ArchiveBuilder::current();
+    return builder->to_requested(builder->get_buffered_addr(m));
+  } else {
+    // Old CDS+AOT workflow.
+    return m;
+  }
+}
+
+#if INCLUDE_CDS_JAVA_HEAP
+int CDSAccess::get_archived_object_permanent_index(oop obj) {
+  return HeapShared::get_archived_object_permanent_index(obj);
+}
+
+oop CDSAccess::get_archived_object(int permanent_index) {
+  return HeapShared::get_archived_object(permanent_index);
+}
+
+static void test_cds_heap_access_api_for_object(oop obj) {
+  LogStreamHandle(Info, cds, jit) log;
+
+  obj->print_on(&log);
+  log.cr();
+
+  int n = CDSAccess::get_archived_object_permanent_index(obj); // call this when -XX:+StoreCachedCode
+  if (n < 0) {
+    log.print_cr("*** This object is not in CDS archive");
+  } else {
+    log.print_cr("CDSAccess::get_archived_object_permanent_index(s) = %d", n);
+    oop archived_obj = CDSAccess::get_archived_object(n); // call this when -XX:+LoadCachedCode
+    if (archived_obj == obj || archived_obj == HeapShared::orig_to_scratch_object(obj)) {
+      log.print_cr("CDSAccess::get_archived_object(%d) returns the same object, as expected", n);
+    } else {
+      log.print_cr("Error!!! CDSAccess::get_archived_object(%d) returns an unexpected object", n);
+      if (archived_obj == nullptr) {
+        log.print_cr("--> null");
+      } else {
+        archived_obj->print_on(&log);
+        log.cr();
+      }
+    }
+  }
+}
+
+// TEMP: examples for using the CDSAccess::get_archived_object_permanent_index() and CDSAccess::get_archived_object()
+// APIs for the AOT compiler.
+
+void CDSAccess::test_heap_access_api() {
+  ResourceMark rm;
+  const char* tests[] = {
+    "",
+    "null",
+    "NARROW",
+    "not in cds",
+    nullptr,
+  };
+
+  LogStreamHandle(Info, cds, jit) log;
+
+  int i;
+  for (i = 0; tests[i] != nullptr; i++) {
+    EXCEPTION_MARK;
+    log.print_cr("Test %d ======================================== \"%s\"", i, tests[i]);
+    oop s = StringTable::intern(tests[i], CHECK);
+    test_cds_heap_access_api_for_object(s);
+  }
+
+  log.print_cr("Test %d ======================================== Universe::null_ptr_exception_instance()", i);
+  test_cds_heap_access_api_for_object(Universe::null_ptr_exception_instance());
+}
+
+// new workflow only
+void* CDSAccess::allocate_from_code_cache(size_t size) {
+  assert(CDSConfig::is_dumping_final_static_archive(), "must be");
+  return (void*)ArchiveBuilder::cc_region_alloc(size);
+}
+
+size_t CDSAccess::get_cached_code_size() {
+  return _cached_code_size;
+}
+
+void CDSAccess::set_cached_code_size(size_t sz) {
+  _cached_code_size = sz;
+}
+
+void CDSAccess::set_pointer(address* ptr, address value) {
+  ArchiveBuilder* builder = ArchiveBuilder::current();
+  if (value != nullptr && !builder->is_in_buffer_space(value)) {
+    value = builder->get_buffered_addr(value);
+  }
+  *ptr = value;
+  ArchivePtrMarker::mark_pointer(ptr);
+}
+
+bool CDSAccess::map_cached_code(ReservedSpace rs) {
+  FileMapInfo* static_mapinfo = FileMapInfo::current_info();
+  assert(UseSharedSpaces && static_mapinfo != nullptr, "must be");
+  return static_mapinfo->map_cached_code_region(rs);
+}
+
+#endif // INCLUDE_CDS_JAVA_HEAP
diff a/src/hotspot/share/cds/cdsAccess.hpp b/src/hotspot/share/cds/cdsAccess.hpp
--- /dev/null
+++ b/src/hotspot/share/cds/cdsAccess.hpp
@@ -0,0 +1,73 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+#ifndef SHARE_CDS_CDSACCESS_HPP
+#define SHARE_CDS_CDSACCESS_HPP
+
+#include "cds/archiveBuilder.hpp"
+#include "cds/archiveUtils.hpp"
+#include "memory/allStatic.hpp"
+#include "oops/oopsHierarchy.hpp"
+#include "utilities/globalDefinitions.hpp"
+
+class InstanceKlass;
+class Klass;
+class Method;
+class ReservedSpace;
+
+class CDSAccess : AllStatic {
+private:
+  static bool can_generate_cached_code(address addr) NOT_CDS_RETURN_(false);
+public:
+  static bool can_generate_cached_code(Method* m) {
+    return can_generate_cached_code((address)m);
+  }
+  static bool can_generate_cached_code(Klass* k) {
+    return can_generate_cached_code((address)k);
+  }
+  static bool can_generate_cached_code(InstanceKlass* ik) NOT_CDS_RETURN_(false);
+
+  static uint delta_from_shared_address_base(address addr);
+  static Method* method_in_cached_code(Method* m) NOT_CDS_RETURN_(nullptr);
+
+  static int get_archived_object_permanent_index(oop obj) NOT_CDS_JAVA_HEAP_RETURN_(-1);
+  static oop get_archived_object(int permanent_index) NOT_CDS_JAVA_HEAP_RETURN_(nullptr);
+
+  static void test_heap_access_api() NOT_CDS_JAVA_HEAP_RETURN;
+
+  static void* allocate_from_code_cache(size_t size) NOT_CDS_RETURN_(nullptr);
+
+  static size_t get_cached_code_size() NOT_CDS_JAVA_HEAP_RETURN_(0);
+  static void set_cached_code_size(size_t sz) NOT_CDS_JAVA_HEAP_RETURN;
+
+  static bool map_cached_code(ReservedSpace rs) NOT_CDS_JAVA_HEAP_RETURN_(false);
+
+  template <typename T>
+  static void set_pointer(T** ptr, T* value) {
+    set_pointer((address*)ptr, (address)value);
+  }
+  static void set_pointer(address* ptr, address value);
+};
+
+#endif // SHARE_CDS_CDSACCESS_HPP
